﻿# Script will generate urBackup report for daily status

$ErrorActionPreference = "SilentlyContinue";
# Gets directory of script
$scriptpath = $MyInvocation.MyCommand.Definition 
$dir = Split-Path $scriptpath 

#Variables to configure
#smtpServer is the server used to send emails
#ReportSender is the email account used to send the email
#users are the to: email accounts
#leaving this section empty will just create a daily report in the Logs folder
$smtpServer = "mail.bigpond.com" 
$ReportSender = "xyz@bigpond.com"  
$users = "abc@email.com.au", "def@email.com.au"; 
# These are the disk percentages that show yellow or red
$percentWarning = 25;
$percentCritcal = 15;

#from here don't make changes unless you know what you are doing
$titleDate = get-date -uformat "%m-%d-%Y - %A"
$MailSubject = "UrBackup Report for $titledate"

$reportPath = $dir + "\Logs\"
$inputFile = $dir + "\clients3.txt"
$sqlitepath = $dir + "\sqlite\"
$reportName = "$(get-date -format ddMMyyyy)_urBackupRpt.html";
$BackupReport = $reportPath + $reportName
$redColor = "'#FF0000'"
$yellowColour = "<TD bgcolor='#FBB917' align='middle'>"
$greenColour = "<TD bgcolor='#7FFF00' align='middle'>"
$redColour = "<TD bgcolor='#FF0000' align='middle'>"
(Get-Content $inputFile) -replace '<TD>RED-', $redColour | Set-Content $inputFile
(Get-Content $inputFile) -replace '<TD>YELLOW-', $yellowColour | Set-Content $inputFile
(Get-Content $inputFile) -replace '<TD>GREEN-', $greenColour | Set-Content $inputFile
$inputtext = Get-Content -Path $inputFile

Set-Content -Path $BackupReport -Value '<table>'
Add-Content -Path $BackupReport -Value '<style> table, th, td {   border: 1px solid black; } </style>'
Add-Content -Path $BackupReport -Value '<th style="width:130px">Name</th>'
Add-Content -Path $BackupReport -Value '<th style="width:150px">Last Backup</th>'
Add-Content -Path $BackupReport -Value '<th style="width:40px">Hours</th>'
Add-Content -Path $BackupReport -Value '<th style="width:150px">Last Online</th>'
Add-Content -Path $BackupReport -Value '<th style="width:60px">Size GB</th>'
Add-Content -Path $BackupReport -Value '<th style="width:60px">Success</th>'
Add-Content -Path $BackupReport -Value $inputtext
Add-Content -Path $BackupReport -Value '</table>'


# Script will generate Disk Space Report Server

$ErrorActionPreference = "SilentlyContinue";
$scriptpath2 = $MyInvocation.MyCommand.Definition 
$dir2 = Split-Path $scriptpath2
$reportPath2 = "$dir2\Logs\"
$reportName2 = "$(get-date -format ddMMyyyy)_DiskSpaceRpt.html";
$diskReport = $reportPath2 + $reportName2
$redColor = "#FF0000"
$orangeColor = "#FBB917"
$whiteColor = "#FFFFFF"
$greenColor = "#7FFF00"
$i = 0;
$computers = Get-Content "$dir\servers_list.txt";
$datetime = Get-Date -Format "MM-dd-yyyy_HHmmss";
If (Test-Path $diskReport)
    {
        Remove-Item $diskReport
    }
$titleDate = get-date -uformat "%m-%d-%Y - %A"
$header = "
		<html>
		<head>
		<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>
		<title>DiskSpace Report</title>
		<STYLE TYPE='text/css'>
		<!--
        	table {
            		border: thin solid #666666;
        	}
		td {
			font-family: Tahoma;
			font-size: 11px;
			border-top: 1px solid #999999;
			border-right: 1px solid #999999;
			border-bottom: 1px solid #999999;
			border-left: 1px solid #999999;
			padding-top: 0px;
			padding-right: 0px;
			padding-bottom: 0px;
			padding-left: 0px;
		}
		body {
			margin-left: 5px;
			margin-top: 5px;
			margin-right: 0px;
			margin-bottom: 10px;
			table {
			border: thin solid #000000;
		}
		-->
		</style>
		</head>
		<body>
		<table width='100%'>
		<tr bgcolor='#CCCCCC'>
		<td colspan='7' height='25' align='center'>
		<font face='tahoma' color='#003399' size='4'><strong>DiskSpace Report for $titledate</strong></font>
		</td>
		</tr>
		</table>
"
 Add-Content $diskReport $header
 $tableHeader = "
 <table width='100%'><tbody>
	<tr bgcolor=#CCCCCC>
    <td width='10%' align='center'>Server</td>
	<td width='5%' align='center'>Drive Label</td>
	<td width='15%' align='center'>Drive</td>
	<td width='10%' align='center'>Total Capacity(GB)</td>
	<td width='10%' align='center'>Used Capacity(GB)</td>
	<td width='10%' align='center'>Free Space(GB)</td>
	<td width='5%' align='center'>Freespace %</td>
	</tr>
"
Add-Content $diskReport $tableHeader
  foreach($computer in $computers)
	{	
	$disks = Get-WmiObject -ComputerName $computer -Class Win32_Volume -Filter "DriveType = 3" | Where-Object {$_.Label -ne "System Reserved"}
	$computer = $computer.toupper()
		foreach($disk in $disks)
	{        
		$deviceID = $disk.Label;
        	$volName = $disk.Name;
		[float]$size = $disk.Capacity;
		[float]$freespace = $disk.FreeSpace; 
		$percentFree = [Math]::Round(($freespace / $size) * 100, 2);
		$sizeGB = [Math]::Round($size / 1073741824, 2);
		$freeSpaceGB = [Math]::Round($freespace / 1073741824, 2);
        $usedSpaceGB = [Math]::Round($sizeGB - $freeSpaceGB, 2);
        $color = $greenColor;
	if($percentFree -lt $percentWarning)      
		{
	   $color = $orangeColor	
      if($percentFree -lt $percentCritcal)
        {
        $color = $redColor
        }
        }        
    $dataRow = "
		<tr>
        <td width='10%'>$computer</td>
		<td width='5%' align='center'>$deviceID</td>
		<td width='15%' >$volName</td>
		<td width='10%' align='center'>$sizeGB</td>
		<td width='10%' align='center'>$usedSpaceGB</td>
		<td width='10%' align='center'>$freeSpaceGB</td>
		<td width='5%' bgcolor=`'$color`' align='center'>$percentFree</td>
		</tr>
"
Add-Content $diskReport $dataRow;
Write-Host -ForegroundColor DarkYellow "$computer $deviceID percentage free space = $percentFree";
    $i++		
	}
}
 $tableDescription = "
 </table><br><table width='20%'>
	<tr bgcolor='White'>
    <td width='10%' align='center' bgcolor='#FBB917'>Warning less than $percentWarning% free space</td>
	<td width='10%' align='center' bgcolor='#FF0000'>Critical less than $percentCritcal% free space</td>
	</tr>
"
 	Add-Content $diskReport $tableDescription
	Add-Content $diskReport "</body></html>"


foreach ($user in $users)
{
        Write-Host "Sending Email notification to $user"
		
		$smtp = New-Object Net.Mail.SmtpClient($smtpServer)
		$msg = New-Object Net.Mail.MailMessage
		$msg.To.Add($user)
        $msg.From = $ReportSender
		$msg.Subject = $MailSubject
        $msg.IsBodyHTML = $true
        $msg.Body = get-content $BackupReport, $diskReport
        #$msg.Body = get-content $diskReport
		$smtp.Send($msg)
        $body = ""
    }
